	#include "system.h"

	/******************************************
	    Stripped down crt0 for the bootrom
	    
	 Sets up icache, dcache, stack, gp, 
	 clears bss, and then jumps to main
	 ******************************************/
	 
	 
	.globl main

	.globl __bss_start
	.globl __bss_end
	
	

    .section .entry, "xa"
    .align 5

    .set noat
    


    .globl __reset
    .type __reset, @function
__reset:
    movui r2, NIOS2_ICACHE_SIZE
0:
    initi r2
    addi r2, r2, - NIOS2_ICACHE_LINE_SIZE
    bgt r2, zero, 0b
1:

    movhi r1, %hi(_start)
    ori r1, r1, %lo(_start)
    jmp r1

	nop
__except:	
	br		__except
//	movhi	et,%hi(EXCEPTCNT_BASE)
//	addi	et,et,%lo(EXCEPTCNT_BASE)
//	ldw		et,0(et)
//	jmp		et

    .section .text
    .align 2
    .globl _start
    .type _start, @function    
_start:


    movui r2, NIOS2_DCACHE_SIZE
0:
    initd 0(r2)
    addi r2, r2, - NIOS2_DCACHE_LINE_SIZE
    bgt r2, zero, 0b
1:


    movhi sp, %hi(__alt_stack_pointer)
    ori sp, sp, %lo(__alt_stack_pointer)

    movhi gp, %hi(_gp)
    ori gp, gp, %lo(_gp)

    movhi r2, %hi(__bss_start)
    ori r2, r2, %lo(__bss_start)

    movhi r3, %hi(__bss_end)
    ori r3, r3, %lo(__bss_end)

    beq r2, r3, 1f 

0:
    stw zero, (r2)
    addi r2, r2, 4
    bltu r2, r3, 0b

1:

    call main

    /* Wait in infinite loop in case alt_main does return. */
mainret:
    br mainret
